<?php

#============================================================
# URL SHRTN             | URL shortening/forwarding script
#------------------------------------------------------------
# Script provided by Glype Media, http://www.glype.com/
#============================================================

# This is the installation file
# Processing submitted details

# Check compatability
require 'check.php';

# Attempt mysql connection
$host = clean($_POST['mysqlhost']);
$user = clean($_POST['mysqluser']);
$pass = clean($_POST['mysqlpass']);
$db = clean($_POST['mysqldb']);

if (! $conn = @mysql_connect($host,$user,$pass) )
	error('Failed mysql connection','
	<p>We could not connect to MySQL with the information you supplied.</p>
	<p>Please <a href="javascript:history.go(-1);">go back</a> and check the MySQL details.</p>
	<p>'.mysql_error().'</p>');

# Check mysql database
if (! mysql_select_db($db,$conn) )
	error('Could not find database','
	<p>We successfully connected to your MySQL server but could not find the database you specified.</p>
	<p>'.mysql_error().'</p>
	<p>Please <a href="javascript:history.go(-1);">go back</a> and check the MySQL database name.</p>');

# Create table
mysql_query(
'CREATE TABLE IF NOT EXISTS shrt_urls (
  id int(10) NOT NULL,
  custom tinyint(1) NOT NULL,
  destination varchar(255) collate latin1_general_ci NOT NULL,
  cloak tinyint(1) NOT NULL,
  showTarget tinyint(1) NOT NULL,
  privatePassword varchar(32) collate latin1_general_ci NOT NULL,
  editPassword char(32) collate latin1_general_ci NOT NULL,
  hits int(5) NOT NULL,
  lastHit int(10) NOT NULL,
  createIP int(10) NOT NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;'
) or error('Query failed. '.mysql_error());

# Determine url format
if ( empty($_POST['url']) )
	error('No URL format selected.','<p>Please <a href="javascript:history.go(-1);">go back</a> and choose a URL format.</p>');
switch($_POST['url']) {
	case 'no':
		$urlFormat = $URL.'go.php?s=[KEY]';
		$rewriteInfo = 'You chose to use no rewriting. By default, the files are packed for option (2) which utilizes mod_rewrite to emulate directories. The .htaccess file supplied with the installation does not apply for your configuration and may interfere with the normal working of the software if your server is capable of processing the rewrites. We recommend you delete the .htaccess file at '.$URL.'.htaccess</p>';
		break;
	case 'dir':
		$urlFormat = $URL.'[KEY]';
		$rewriteInfo = 'You chose to emulate directories for your site. This is the default option where supported and as such you should find the existing .htaccess file is already applying the required rewrite.';
		break;
	case 'sub':
		$urlFormat = preg_replace('@://(www\.)?@i','://[KEY].',$URL);
		$rewriteInfo = 'You chose to emulate subdomains for your site. Unless you can already access your site from any possible subdomain, you will need to setup a wildcard DNS. For more information, visit <a href="http://www.glype.com/urlshrtn/wildcarddns">glype.com</a>. When this is completed, you should delete the existing .htaccess file and rename subdomain.htaccess to .htaccess to replace it.</p>';
		break;
	default:
		error('Invalid URL format chosen');
}

# Check user/pass
if ( empty($_POST['adminuser']) || empty($_POST['adminpass']) )
	error('No admin account chosen.','<p>Please <a href="javascript:history.go(-1);">go back</a> and choose a username and password to administer your site.</p>');

# All OK, write the config file
$handle = fopen(PATH.S.'includes'.S.'config.php','wb') or error('Could not write config file','<p>Please check permissions on <b>/includes/config.php</b></p>');
fwrite($handle,'<?php
$CONFIG[\'siteName\'] = \''.addslashes(clean($_POST['sitename'])).'\';
$CONFIG[\'urlFormat\'] = \''.$urlFormat.'\';
$CONFIG[\'baseURL\'] = \''.$URL.'\';
$CONFIG[\'useHTTP\'] = true;
$CONFIG[\'timezone\'] = \'Europe/London\';
$CONFIG[\'mysqlHost\'] = \''.addslashes($host).'\';
$CONFIG[\'mysqlUser\'] = \''.addslashes($user).'\';
$CONFIG[\'mysqlPass\'] = \''.addslashes($pass).'\';
$CONFIG[\'mysqlDb\'] = \''.addslashes($db).'\';
$CONFIG[\'whitelist\'][\''.addslashes(clean($_POST['adminuser'])).'\'] = \''.addslashes(clean($_POST['adminpass'])).'\';
$CONFIG[\'acpPage\'] = 40;
?>');

# Top skin
include 'skin_top.php';

# Print page
echo '
<h3>Success! URL Shrtn was installed.</h3>
<p>You can access your site at <a href="',$URL,'">',$URL,'</a>. For maintenance, visit the admin control panel at <a href="',$URL,'admin">/admin/</a>.</p>
<p>You <strong>must</strong> now delete this /install/ directory before it is safe to launch your site.</p>
<p>',$rewriteInfo,'</p>
<p>Visit <a href="http://www.glype.com/urlshrtn/">glype.com</a> for additional information on customizing and configuring your URL shrtn installation.</p>
';

# Bottom skin
include 'skin_bottom.php';

?>